[![KendoReact NPM Banner](https://raw.githubusercontent.com/telerik/kendo-react/master/images/kendoreact-github-banner.png)](https://www.telerik.com/kendo-react-ui/components/free?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip&utm_content=banner)

# KendoReact Tooltips Library for React

> **Important**
>
> -   This package is а part of [KendoReact](https://www.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)&mdash;an enterprise-grade UI library with 120+ free and premium components.
> -   This package contains free KendoReact components. You can use it even in production, no sign-up or license required. If you're looking for more free React components, check out [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free).
> -   Installing and working with this package indicates that you [accept the KendoReact License Agreement](https://www.telerik.com/purchase/license-agreement/progress-kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip).
> -   The [30-day free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip) gives you access to all KendoReact components and their full functionality. Additionally, for the period of your trial, you can use our legendary technical support provided directly by the KendoReact dev team!

The React Tooltips library, part of KendoReact, represents popups with information that is related to a UI element. They get displayed when the user clicks or hovers over this UI element.

How to start:

```sh
npm i @progress/kendo-react-tooltip
```

What's in this package:

-   [React Tooltips Components Library Features](#react-tooltips-components-library-features)
-   [React Tooltip component (free)](#react-tooltip-component)
-   [React Popover component (free)](#react-popover-component)

Additional information:

-   [Support Options](#support-options)
-   [Resources](#resources)
-   [KendoReact Tooltips API](https://www.telerik.com/kendo-react-ui/components/tooltip/api)

## React Tooltips Components Library Features

Among the features which the KendoReact Tooltips are:

-   **Positioning**&mdash;By default, the position of the Tooltip is determined by the available space around it. Additionally, you can set specific position from a property.
-   **Theme support**&mdash;The KendoReact Tooltips, as well as all 120+ components in the KendoReact suite, are styled in three polished themes (Bootstrap, Material, Fluent, and Default) and can be further customized to match your specific design guidelines.

## React Tooltip

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact Tooltip component](https://www.telerik.com/kendo-react-ui/components/tooltip/tooltip?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip), part of KendoReact, provides a popup with information that is related to a particular UI element. The React Tooltip can be displayed when hovering over or clicking on an element.

Key features:

-   [Controlled mode](https://www.telerik.com/kendo-react-ui/components/tooltip/controlled-mode/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)&mdash;Supports both standard tooltip visualization, by hovering and showing it programmatically.
-   [Anchor elements](https://www.telerik.com/kendo-react-ui/components/tooltip/anchor-elements/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)&mdash;You can target specific anchor elements which will render a tooltip.
-   [Templates](https://www.telerik.com/kendo-react-ui/components/tooltip/templates/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)&mdash;You can provide a custom rendering for the content of the Tooltip.
-   [Multiple tooltips](https://www.telerik.com/kendo-react-ui/components/tooltip/multiple-tooltips/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)&mdash;Enables the visualization of multiple tooltips on the same page.
-   [Customization](https://www.telerik.com/kendo-react-ui/components/tooltip/tooltip-customization/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)&mdash;You can place the Tooltip in a specific location and attach its handlers there.

How to use the Tooltip component in your apps:

```tsx
import { Tooltip } from '@progress/kendo-react-tooltip';
...
<Target
    anchorElement="pointer|target"
    position="auto|right|left|bottom|top"
>
    /**
    * Wrap the Tooltip component around the UI element for which you want to show the Tooltip.
    */
</Target>
```

## React Popover

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact Popover component](https://www.telerik.com/kendo-react-ui/components/tooltip/popover/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip), part of KendoReact, is a popup with rich interactable content, which is displayed when a user clicks or hovers over the related UI element.

How to use the Popover component in your apps:

```tsx
import { Popover, PopoverActionsBar } from '@progress/kendo-react-tooltip';
import { Button } from '@progress/kendo-react-buttons'; // You can import any other component that allows user interaction within the PopoverActionsBar. You may need to install additional dependencies, if you're not using components from the Buttons package.
...
/** Handle the logic for showing the Popover.
* Handle setting the anchor for the Popover.
*/
<Popover
  show={show}
  anchor={anchor.current && anchor.current.element}
  title={'Title'}
>
  /**
  * Show additional content in the Popover. For example, images or text.
  */
  <PopoverActionsBar>
    /**
    * Provide UI elements for user actions. For example, buttons.
    */
  </PopoverActionsBar>
</Popover>
```

## Support Options

For any issues you might encounter while working with the KendoReact Tooltip, use any of the available support channels:

-   Industry-leading technical support&mdash;KendoReact paid license holders and users with an active (free) trial license can take advantage of our outstanding customer support. To submit a ticket, use [the dedicated KendoReact support system](https://www.telerik.com/account/support-center/contact-us/technical-support?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listview).
-   Product forums&mdash;The [KendoReact forums](https://www.telerik.com/forums/kendo-ui-react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listview) are part of the free support you can get from the community and from the KendoReact team.
-   Feedback portal&mdash;The [KendoReact feedback portal](https://feedback.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip) is where you can request and vote for new features to be added.

## Resources

-   [Getting Started with KendoReact](https://www.telerik.com/kendo-react-ui/components/getting-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)
-   [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free)
-   [Get Started with the KendoReact Tooltip](https://www.telerik.com/kendo-react-ui/components/tooltip/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)
-   [API Reference of the KendoReact Tooltip](https://www.telerik.com/kendo-react-ui/components/tooltip/api/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)
-   [KendoReact Roadmap](https://www.telerik.com/support/whats-new/kendo-react-ui/roadmap?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)
-   [Blogs](https://www.telerik.com/blogs/tag/kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)
-   [Demos, documentation, and component reference](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)
-   [KendoReact pricing and licensing](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)
-   [Changelog](https://www.telerik.com/kendo-react-ui/components/changelogs/ui-for-react/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-tooltip)

High-level component overview pages:

-   [React Popover Component](https://www.telerik.com/kendo-react-ui/popover)
-   [React Tooltip Component](https://www.telerik.com/kendo-react-ui/tooltip)

_Copyright © 2025 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved._

_Progress, Telerik, and certain product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries._
